#!/bin/sh

PLUGIN_H=$1/plugin_include.h
HEADER_C_IN=$2/_header.c.in
SYMBOL_C_IN=$2/_symbol.c.in
FOOTER_C_IN=$2/_footer.c.in
PLUGIN_TEMPLATE_DIR=$3

for Plugin in `ls $PLUGIN_TEMPLATE_DIR/*.plugin`; do

. $Plugin

echo -n "typedef struct _$STRUCT_PREFIX" >> $PLUGIN_H
echo -n "Plugin $STRUCT_PREFIX" >> $PLUGIN_H
echo "Plugin;" >> $PLUGIN_H
echo >> $PLUGIN_H

echo -n "struct _$STRUCT_PREFIX" >> $PLUGIN_H
echo "Plugin {" >> $PLUGIN_H
echo >> $PLUGIN_H
echo "	gchar* name; " >>$PLUGIN_H
echo >> $PLUGIN_H

    for Member in `cat $Plugin.members`; do

	FUNC_NAME=`echo $Member|cut -f1 -d \:`
	MEMB_NAME=`echo $Member|cut -f2 -d \:`

	echo "	$FUNC_NAME	$MEMB_NAME;" >> $PLUGIN_H 

    done


echo "};" >> $PLUGIN_H
echo >> $PLUGIN_H

done

echo "typedef enum {" >> $PLUGIN_H
echo >> $PLUGIN_H

for Plugin in `ls $PLUGIN_TEMPLATE_DIR/*.plugin`; do

. $Plugin

echo "	BMP_PLUGINS_TYPE_$PLUGIN_TYPE_NAME," >> $PLUGIN_H

done

echo >> $PLUGIN_H
echo "	BMP_PLUGIN_N_TYPES" >> $PLUGIN_H
echo "} BmpPluginType;" >> $PLUGIN_H

